ENTRY(entry_x86)

SECTIONS {
    . = 1M;

    .text BLOCK(4K) : ALIGN(4K)
    {
        *(.mb2_header)
        *(.text)
    }

    /* Read-only data. */
	.rodata BLOCK(4K) : ALIGN(4K)
	{
		*(.rodata)
	}
 
	/* Read-write data (initialized) */
	.data BLOCK(4K) : ALIGN(4K)
	{
		*(.data)
	}
 
	/* Read-write data (uninitialized) and stack */
	.bss BLOCK(4K) : ALIGN(4K)
	{
		*(COMMON)
		*(.bss)
	}
}